VERSION 4.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Brightness & Contrast"
   ClientHeight    =   2175
   ClientLeft      =   2070
   ClientTop       =   2520
   ClientWidth     =   4350
   Height          =   2955
   Left            =   2010
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2175
   ScaleWidth      =   4350
   Top             =   1800
   Width           =   4470
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      LargeChange     =   10
      Left            =   2520
      Max             =   100
      TabIndex        =   2
      Top             =   1680
      Width           =   1335
   End
   Begin VB.Frame Frame1 
      Caption         =   "Image Processor"
      Height          =   1335
      Left            =   2550
      TabIndex        =   0
      Top             =   120
      Width           =   1695
      Begin VB.OptionButton optProcessor 
         Caption         =   "Gamma"
         Height          =   255
         Index           =   2
         Left            =   120
         TabIndex        =   8
         Top             =   960
         Width           =   1095
      End
      Begin VB.OptionButton optProcessor 
         Caption         =   "Contrast"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   7
         Top             =   600
         Width           =   1095
      End
      Begin VB.OptionButton optProcessor 
         Caption         =   "Brightness"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Width           =   1095
      End
   End
   Begin ik32Lib.Picbuf PicbufOriginal 
      Height          =   495
      Left            =   2280
      TabIndex        =   6
      Top             =   960
      Width           =   735
      _Version        =   65536
      _ExtentX        =   1296
      _ExtentY        =   873
      _StockProps     =   253
   End
   Begin ik32Lib.Picbuf PicbufEdit 
      Height          =   495
      Left            =   2280
      TabIndex        =   5
      Top             =   360
      Width           =   615
      _Version        =   65536
      _ExtentX        =   1085
      _ExtentY        =   873
      _StockProps     =   253
   End
   Begin ik32Lib.Picbuf PicbufVisible 
      Height          =   2055
      Left            =   120
      TabIndex        =   4
      Top             =   0
      Width           =   2295
      _Version        =   65536
      _ExtentX        =   4048
      _ExtentY        =   3625
      _StockProps     =   253
   End
   Begin VB.Label lblScrollChange 
      Alignment       =   2  'Center
      Caption         =   "0.5"
      Height          =   255
      Left            =   3900
      TabIndex        =   3
      Top             =   1680
      Width           =   405
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   2280
      Top             =   1800
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuLoad 
         Caption         =   "&Load Image..."
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save Image..."
      End
      Begin VB.Menu mnuSpacer 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
         Shortcut        =   ^X
      End
   End
   Begin VB.Menu mnuReload 
      Caption         =   "&Reload"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
'Description: Here we set a few global variables,
'to keep track of the brightness, contrast, and
'gamma settings throughout the code
Option Explicit
Public nBrightness, nContrast, nGamma As Double, flagLoad As Boolean





Sub ResetValues()
    HScroll1.Value = 50
    nBrightness = 0.5
    nContrast = 0.5
    nGamma = 5
End Sub




'Description: This sub defines all presets.
Private Sub Form_Load()
    'Set Brightness/Contrast/Gamma values
    nBrightness = 0.5
    nContrast = 0.5
    nGamma = 5
    
    'Set PicBuf properties
    PicbufOriginal.Visible = False
    PicbufEdit.Visible = False
    InitPicbuf PicbufVisible, False
    PicbufOriginal.Filename = App.Path + "\..\images\leaves8.pcx"
    PicbufOriginal.Load
End Sub


'Description: At this point we decide which values
'have been chosen, and then update the image
'accordingly
Private Sub HScroll1_Change()
    Select Case True
        Case optProcessor(0).Value
            nBrightness = HScroll1.Value / 100
            'Set image brightness\contrast
            PicbufEdit.BrightCont nBrightness, nContrast
            lblScrollChange.Caption = Mid(Str(nBrightness), 1, 3)
        Case optProcessor(1).Value
            nContrast = HScroll1.Value / 100
            'Set image brightness\contrast
            PicbufEdit.BrightCont nBrightness, nContrast
            lblScrollChange.Caption = Mid(Str(nContrast), 1, 3)
        Case optProcessor(2).Value
            nGamma = HScroll1.Value / 10
            'Set image Gamma
            PicbufEdit.Gamma nGamma
            lblScrollChange.Caption = Str(nGamma)
    End Select
    
    'copy Original image to edit picbuf
    flagLoad = True
    PicbufEdit.Picture = PicbufOriginal.Picture
End Sub




Private Sub mnuExit_Click()
    ExitProgram
End Sub

Private Sub mnuLoad_Click()
    ResetValues
    LoadImage PicbufOriginal, CommonDialog1
End Sub

'Description: This code simply calls the
'PicbufOriginal_Change sub to reload the original
'image.
Private Sub mnuReload_Click()
    ResetValues
    PicbufOriginal_Change
End Sub

Private Sub mnuSave_Click()
    SaveImage PicbufVisible, CommonDialog1
End Sub





'Description: This sets the scroll bar to the current
'value of the brightness    HScroll1.Value = nBrightness
Private Sub optProcessor_Click(Index As Integer)
    Select Case Index
        Case 0
            HScroll1.Value = nBrightness * 100
            lblScrollChange.Caption = Mid(Str(nBrightness), 1, 3)
        Case 1
            HScroll1.Min = 0
            HScroll1.Value = nContrast * 100
            lblScrollChange.Caption = Mid(Str(nContrast), 1, 3)
        Case 2
            HScroll1.Min = 10
            HScroll1.Value = nGamma * 10
            lblScrollChange.Caption = Str(nGamma)
    End Select
End Sub

'Description: Here we copy images from one picbuf
'to another.
Private Sub picbufedit_Change()
    If flagLoad = False Then
        'copy edit picbuf to visible picbuf
        PicbufVisible.Picture = PicbufEdit.Picture
    Else
        flagLoad = False
    End If
End Sub

'Description: Here we copy images from one picbuf
'to another.
Private Sub PicbufOriginal_Change()
    'copy original picbuf to edit picbuf
    PicbufEdit.Picture = PicbufOriginal.Picture
    PicbufVisible.Filename = PicbufOriginal.Filename
End Sub


